import { TYPE_ADS_PAGE, CONFIG_TITLE_DES_PAGE } from './contains';

/* eslint-disable no-new */
if (typeof window !== undefined) {
  new Error('Just server side!');
}

const {
  KEY_SESSION, KEY_SESSION_ADMIN, KEY_TOKEN, SECRET_SESSION, SECRET_COOKIE, EXPIRE_SESSION, SECRET_TOKEN,
  SECRET_REFRESH_TOKEN, EXPIRE_TOKEN, EXPIRE_REFRESH_TOKEN, EXPIRE_TIME_HAS_REMEMBER, EXPIRE_TIME_CACHING,
  REDIS_HOST, REDIS_PORT, REDIS_PASSWORD, EXPIRE_ERROR_FILM_CACHING, SECRET_SESSION_ADMIN, EXPIRE_TIME_MENUS,
} = process.env;

export const FILES_NAME = {
  CONFIG: 'static/page-config.json',
  INDEX: 'static/language/en/post-index.json',
  SLIDER: 'static/language/en/home_text_under_slider.json',
  FAQ: 'static/language/en/faq_post.json',
};

export const KEYS_REDIS = {
  CONFIG: 'CONFIG:PAGE',
  INDEX_CONTENT: 'CONFIG:INDEX_CONTENT',
  SLIDER_CONTENT: 'CONFIG:SLIDER_CONTENT',
  FAQ_CONTENT: 'CONFIG:FAQ_CONTENT',

  MOVIES: 'MVS',
  MOVIE: 'MV',
  MOVIE_RANK: 'MV:RANK',
  MOVIE_RANK_VAL: 'MV:RANK_VAL',
  MOVIE_RANK_EXPIRE: 'MV:RANK-EXPIRE',
  MOVIE_ID_TOOLTIP: 'MV_TOOLTIP',

  TVS: 'TVS',
  TV: 'TV',
  TV_RANK: 'TV:RANK',
  TV_RANK_VAL: 'TV:RANK_VAL',
  TV_RANK_EXPIRE: 'TV:RANK-EXPIRE',
  TV_ID_TOOLTIP: 'TV_TOOLTIP',

  FILTER: 'FILTER',
  MENUS: 'MENUS',
  SLIDERS: 'SLIDERS',
  ERROR_FILM: 'ERROR_FILM',
};

export const configSystem = {

  ACCOUNT_ADMIN: {
    username: 'admin',
    password: 'admin',
  },

  KEY_SESSION: KEY_SESSION || 'Session',
  KEY_TOKEN: KEY_TOKEN || 'Authentication',
  KEY_SESSION_ADMIN: KEY_SESSION_ADMIN || 'SessionAdmin',

  SECRET_SESSION_ADMIN: SECRET_SESSION_ADMIN || 'SECRET_SESSION_ADMIN',
  SECRET_SESSION: SECRET_SESSION || 'Session JWT',
  SECRET_COOKIE: SECRET_COOKIE || 'AES',

  SECRET_TOKEN: SECRET_TOKEN || 'Token JWT',
  SECRET_REFRESH_TOKEN: SECRET_REFRESH_TOKEN || 'Refresh Token JWT',

  EXPIRE_SESSION: +(EXPIRE_SESSION || 60 * 60 * 24 * 4), // 4d,
  EXPIRE_TOKEN: +(EXPIRE_TOKEN || 60 * 60 * 4), // 4h,
  EXPIRE_REFRESH_TOKEN: +(EXPIRE_REFRESH_TOKEN || 60 * 60 * 24), // 1d,
  EXPIRE_TIME_HAS_REMEMBER: +(EXPIRE_TIME_HAS_REMEMBER || 60 * 60 * 24 * 30), // 1month,

  EXPIRE_TIME_CACHING: +(EXPIRE_TIME_CACHING || 60 * 60 * 24), // 1d
  EXPIRE_TIME_MENUS: +(EXPIRE_TIME_MENUS || 60 * 60 * 24 * 5), // 5d

  EXPIRE_ERROR_FILM_CACHING: +(EXPIRE_ERROR_FILM_CACHING || 60 * 60 * 24 * 30), // 1month,

  EXPIRE_TIME_TOP_VIEW: 60 * 60 * 4, // 4h
  REDIS: {
    HOST: REDIS_HOST || 'containers-us-west-14.railway.app',
    PORT: REDIS_PORT || 7281,
    PASSWORD: REDIS_PASSWORD || 'LICb6OXyBDkaHWZqMPfC',
  },
};

const KEYS_ADS = Object.values(TYPE_ADS_PAGE).map((item) => item.key);
const KEYS_DOC = Object.values(CONFIG_TITLE_DES_PAGE).map((item) => item.key);

export const KEYS_CONTENT = [KEYS_REDIS.INDEX_CONTENT, KEYS_REDIS.SLIDER_CONTENT, KEYS_REDIS.FAQ_CONTENT, ...KEYS_ADS, ...KEYS_DOC];

export default configSystem;
